#ifndef CUSTOM_PORT_h
#define CUSTOM_PORT_h

#include "global.h"
#include <Arduino.h>
#include <vector>

#ifdef WILULU32
    void setupW();
    void action_W(const std::vector<uint8_t> & DMXslice);
    void at_each_loop_W();
#endif

void setupA();
void action_A(const std::vector<uint8_t> & DMXslice);
void at_each_loop_A();

#ifdef ARPSCHUINO32
    void setupB();
    void action_B(const std::vector<uint8_t> & DMXslice);
    void at_each_loop_B();
#endif

void setupI2C(uint8_t ID);
void actionI2C(uint8_t ID,const std::vector<uint8_t> & DMXslice);
void at_each_loop_I2C(uint8_t ID);

#endif